/* 
 * CSE142, 98 Autumn
 * Homework 4:			Precipitation Manipulation
 * Rain Goddess:		Marilee Glenn
 * Goddess #:			9728687
 * Supervising Deity:	Mathieu Blanchette, CSE 142 BB
 * Send prayers to:		marileeg@u.washington.edu
*/

#include "gp142.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#define TRUE    		1
#define FALSE   		0

/* Configure the appearance of the buttons on the menu bar */
/* number of pixels of button height and width */
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	100
/* number of buttons to draw */
#define NUM_BUTTONS 	9
/* color of lettering on buttons */
#define SELECTED_COLOR   BLUE
#define UNSELECTED_COLOR BLACK


/* This is the total number of drops possible at one time.*/
#define MAX_PRECIP_EVENTS	500
/* this is the total number of pigs or burn spots possible.*/
#define MAX_GROUND_EVENTS	50
/* number of frames necessary to draw a lightning bolt crash*/
#define LIGHT_FRAMES	5

/* y-ccordinate of the top of the "dirt" in the landscape*/
#define TOP_OF_DIRT (- 2 * (GP142_YMAX / 5))

/* different constants to describe motion */
#define RAIN_SPEED 8
#define SNOW_SPEED 3
#define WIND_SPEED 5

/* gives a screen-width's worth of possible random numbers	*/
#define RAND_X_MAX	(2 * GP142_XMAX)

/* constants for lightning's shape */
#define LIGWIDTH 10
#define LIGHEIGHT 80
/* the y coordinate for the start of a lightning strike	*/
#define TOP_LIGHT	(GP142_YMAX - LIGHEIGHT)

/* For many of the GP142 functions, a line width of
   zero means to fill the shape being drawn. */
#define FILL 0

/* Types of objects we support */
#define NONE 0
#define RAIN 1
#define SNOW 2
#define PIGS 3
#define BURN 4

/*Possible places for mouse clicks*/
#define BUTTON 1
#define DIRT 2

/*******************  FUNCTION PROTOTYPES **************************/

/* redraw all the buttons.
	The parameters tell which buttons should be highlighted.	*/
void DrawButtons(int current_precip, int current_color, 
				 int cur_ground, int Wind_Flag);

/* Both of the next two functions are used for both sky and ground
objects.  The only reason they still say "Precipitation" is that I
didn't go through and change the names. */
/*Clear all precipitation, so the landscape is just as originally */
void  ClearAllPrecipitation (int * length);
/*render (draw) all the precipitation*/
void DrawAllPrecipitation(int Type[], int X[], int Y[], int Color[], 
						  int length);

/*draw a fresh landscape to cover over the old stuff*/
void DrawLandscape();

/*object prototypes to draw all the different objects in any color */
void DrawRainDrop (int x, int y, int color);
void DrawSnowDrop (int x, int y, int color);
void DrawCritter (int color, int x, int y);
void DrawLightning (int x, int y, int x_slant);
void DrawBurn (int center_x, int center_y);

/*Return an integer which tells what KIND of click there was */
int  ClassifyMouseClick(int mouse_x, int mouse_y);

/*Given that a button was clicked, call an appropriate function to 
handle it*/
void handle_button(int x, int y, int *current_precip, 
				   int *current_color, int *cur_ground,
				   int *Wind_Flag, int *clear_weather);

/* catalog what to draw, corresponding to a clicked point */
void add_point (int X[], int Y[], int C[], int Type[], int * p_count,
				int new_color, int new_x, int new_y, int new_type);
void add_ground_point (int X[], int Y[], int Type[], int * p_count, 
					   int new_x, int new_y, int new_type);


/********************************************************************
  MAIN
********************************************************************/

	/* main() has two chief purposes: to contain the important 
	variables and initialize them,
	and to contain the "event loop," which constantly looks to see if
	an event has happened, and then processes the event by calling an
	appropriate function.
	*/
int main(void)
{
	int i;	/*counter*/
	int X[MAX_PRECIP_EVENTS],		/*arrays to hold object info*/
		Y[MAX_PRECIP_EVENTS],		/*first 4 sky, */
		Color[MAX_PRECIP_EVENTS],
		Type[MAX_PRECIP_EVENTS],
		GroundX[MAX_GROUND_EVENTS],	/*2nd 4 ground */
		GroundY[MAX_GROUND_EVENTS],
		GroundColor[MAX_GROUND_EVENTS],
		GroundType[MAX_GROUND_EVENTS],
		lightning_x[5],				/* lightning frame coordinates */
		lightning_y[5];
	char key_hit;					/*useless */

	int sun_x = GP142_XMAX - 50,	/*sun-trackers */
		sun_y = GP142_YMAX - 35;
	int first_light,				/* x coord for top of lightning */
		light_shift;				/* lightning slant				*/
 
	int sky_count=0,				/* counts number of current		*/
		ground_count=0,				/* objects for array arithmetic	*/
		light_count;

	int current_precip = NONE,		/* Last button selections		*/
		current_color = NONE,
		cur_ground = NONE;

	int clear_flag = FALSE;			/* true to clear all weather	*/
	int quit = FALSE;				/* true to close the program	*/
	int Wind_Flag = FALSE;			/* toggle the wind blowing		*/
	int Light_Flag = FALSE;			/* test for lightning crashing	*/

	int mouse_click;				/* classify click				*/
	int mouse_x, mouse_y;			/* last mouse-click locations	*/
	int event;						/* most recent GP142 event		*/
	time_t t;						/* initializer for random #		*/
	
	/*~~~~~~~~~~~~~~~~~~~~~~~ PROGRAM PRIMERS ~~~~~~~~~~~~~~~~~~~~~~*/
	srand (time(&t));		/* Seed the random number generator	*/

	GP142_open();			/* init the GP142 Graphics Window	*/
	GP142_logging(LOG_OFF); /* Keep the logging off				*/
	GP142_clear();			/* clear the window, paint it white	*/
	GP142_animate(ANI_RUN); /* Start animation					*/

	DrawLandscape();		/* Clean start for the graphics		*/
	DrawButtons(current_precip, current_color, cur_ground, Wind_Flag);
	ClearAllPrecipitation (&sky_count);



  /*
   * The main event loop:
   * --- ---- ----- -----
   * wait for the next user action, such as a mouse click or keyboard
   * keypress, or a periodic update event (allowing us to display the
   * next frame of an animation -- not used int this program)
   * and call the appropriate function to
   * handle it.  Repeat this until the user signals "quit".
   */

	while (!quit) {  /*this is the famous "event loop" */

		/*find out what has happened */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);

		switch (event) {
	    case GP142_QUIT:
	      quit = TRUE;           /* set flag to terminate loop           */
	      break;

	    case GP142_KBD:
			/*not needed for this program.*/
			/*Use this if user will need to hit a key.
			/*Note that scanf CANNOT be used with GP142*/
	      break;
	
	    case GP142_MOUSE:
			/* a mouse click has occurred. */
			/* check for button, dirt */
			/* handle appropriate button click, if any */
			mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
			if (mouse_click == BUTTON) {
				/* a button has been clicked; find out which one */
				handle_button(mouse_x, mouse_y, &current_precip,
					&current_color, &cur_ground, &Wind_Flag, 
					&clear_flag);
				if (clear_flag) {
					ClearAllPrecipitation (&sky_count);
					ClearAllPrecipitation (&ground_count);
				}
			} else { if ((mouse_click != DIRT) &&
				/*sky click, and precipitation is selected*/
			 (current_precip != NONE) && (current_color != NONE)){
				add_point (X, Y, Color, Type, &sky_count,
					current_color, mouse_x, mouse_y, current_precip);	
				DrawAllPrecipitation (Type,	X, Y, Color, sky_count);
			} else { 
				if ((mouse_click == DIRT) && (cur_ground != NONE)) {
				 /* handle the special lightning case */
				 if(cur_ground == BURN) {
					 Light_Flag = TRUE;
					 /*generate random origin*/
					 first_light = (int)(rand() % RAND_X_MAX) - 
						 GP142_XMAX;
					 /* start the counter */
					 light_count = 0;
					 /* figure out the slope of the lightning */
					 light_shift=(int)(LIGHEIGHT*
						 (first_light-mouse_x)/(TOP_LIGHT-mouse_y));

					 /* store the coordinates for lightning path */
					 for(i=0;i<LIGHT_FRAMES;i++) {
					  lightning_y[i] = TOP_LIGHT - (int)((TOP_LIGHT -
						  mouse_y)/(LIGHT_FRAMES - 1)) * i;
					  lightning_x[i]=first_light-(int)((first_light - 
						  mouse_x)/(LIGHT_FRAMES - 1)) * i;
					 }
				 }

				 /* Don't allow new ground clicks during lightning */
				 if (Light_Flag == FALSE) {
					 add_ground_point (GroundX, GroundY, GroundType, 
						&ground_count, mouse_x, mouse_y, 
						cur_ground);
				 }
				}
			}
			}
			break;

		
		case GP142_PERIODIC:
 
		for (i=0; i < sky_count; i++) {
			if (Wind_Flag == TRUE) {
				X[i] = X[i] + WIND_SPEED;
			}
			
			if (Type[i] == RAIN)
				Y[i] = Y[i] - RAIN_SPEED;
			else if (Type[i] == SNOW)
				Y[i] = Y[i] - SNOW_SPEED;

			if (Y[i] < (TOP_OF_DIRT - 30)){
				Y[i] = GP142_YMAX - (int)(rand() % 50);
				X[i] = (int)(rand() % RAND_X_MAX) - GP142_XMAX;
			}

			if (X[i] > GP142_XMAX) {
				X[i] = -GP142_XMAX;
			}
		}
		sun_x --;
		if (sun_x < -GP142_XMAX -30) {
			sun_x = - sun_x;
			sun_y = sun_y -1;
		}		/* over a long period of time, the sun will set.*/

		if (Light_Flag == TRUE) {
			light_count++;
			if (light_count>=LIGHT_FRAMES) { /* lightning's over, reset */
				Light_Flag = FALSE;
				light_count = 0;
				/* now the burn mark... */
				add_ground_point (GroundX, GroundY, GroundType,
					&ground_count, lightning_x[LIGHT_FRAMES-1],
					lightning_y[LIGHT_FRAMES-1], BURN);
			}
		
		}
      break;

    default:

      break;
	
    }  /*end switch */

    /* Redraw everything */
    DrawLandscape(sun_x, sun_y);
    DrawButtons(current_precip, current_color, cur_ground, Wind_Flag);
	DrawAllPrecipitation(GroundType, GroundX, GroundY, GroundColor,
		ground_count);
    DrawAllPrecipitation(Type, X, Y, Color, sky_count);
	if (Light_Flag == TRUE) {
		DrawLightning(lightning_x[light_count],
			lightning_y[light_count], light_shift);
	}


    }/* end event loop */

	
	GP142_close();         /* clean up and close graphics window   */
	return 0;
}  /*end main */

/*********************************************************************

     FUNCTIONS

*********************************************************************/




void add_point (int X[], int Y[], int C[], int Type[], int * p_count,
				int new_color, int new_x, int new_y, int new_type){
	int i;
	if (* p_count >= (MAX_PRECIP_EVENTS - 1))
		* p_count = MAX_PRECIP_EVENTS - 2;
	i = * p_count;
	while (i >= 0){
		X[i+1] = X[i];
		Y[i+1] = Y[i];
		C[i+1] = C[i];
		Type[i+1] = Type[i];
		i--;
	}
	X[0] = new_x;
	Y[0] = new_y;
	C[0] = new_color;
	Type[0] = new_type;
	(* p_count)++;
}


void add_ground_point (int X[], int Y[], int Type[], int * p_count, 
					   int new_x, int new_y, int new_type){
	int i;
	if (* p_count >= (MAX_GROUND_EVENTS - 1))
		* p_count = MAX_GROUND_EVENTS - 2;
	i = * p_count;
	while (i >= 0){
		X[i+1] = X[i];
		Y[i+1] = Y[i];
		Type[i+1] = Type[i];
		i--;
	}
/* make sure not to run into the mountains */
	if (new_y > TOP_OF_DIRT - 10)
		new_y = TOP_OF_DIRT - 10;
	X[0] = new_x;
	Y[0] = new_y;
	Type[0] = new_type;
	(* p_count)++;
}



	/*reinitialize so that ALL current precipitation is erased.
	*/
void ClearAllPrecipitation (int* length) {
  *length = 0;
}



void DrawAllPrecipitation(int Type[], int X[], int Y[], int Color[],
						  int length)
{
	int i;
	for (i=length-1; i>=0; i--) {	/*I'm doing this from top to */
		switch (Type[i]) {			/*bottom to display the most */
		case RAIN:					/*recent clicks on top		 */
			DrawRainDrop (X[i], Y[i], Color[i]);
			break;
		case SNOW:
			DrawSnowDrop (X[i], Y[i], Color[i]);
			break;
		case PIGS:
			DrawCritter (PEACH, X[i], Y[i]);
			break;
		case BURN:
			DrawBurn (X[i], Y[i]);
			break;
		default:
			/*Bad news to ever get here.*/
			break;
		/* end switch*/
		}
	}
}





void DrawLandscape(int sun_x, int sun_y)
{  
	int text_offset = -GP142_XMAX + 15, font_size = 14;

	/* Draw the sky first */
	GP142_rectangleXY(ICE_BLUE, -GP142_XMAX, -GP142_YMAX, GP142_XMAX,
		GP142_YMAX, FILL);
 
	/* Draw the sun */
	GP142_circleXY(YELLOW, sun_x, sun_y , 20);

	/* Draw the dirt */
	/* The dirt is a % of the height of the screen */
	GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX, GP142_XMAX,
		TOP_OF_DIRT, FILL);
	GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, font_size,
	  "Click a weather type and a color, then click on the picture.");

	/*Draw the mountains */
	GP142_triangleXY(MED_GRAY, -GP142_XMAX, TOP_OF_DIRT, GP142_XMAX,
		TOP_OF_DIRT, 0, (4 * GP142_YMAX)/5, FILL);

	GP142_triangleXY(LT_GRAY,		/* draw snowcap */
		   -70, 130,
		   70, 130,
		   0, (4 * GP142_YMAX)/5 ,
		   FILL);

	GP142_triangleXY(LT_GRAY,		/* draw rounding for snowcap */
		   -70, 130,
		   70, 130,
		   0, (4 * GP142_YMAX)/8 ,
		   FILL);

  GP142_triangleXY(OLIVE,
		   -( 5 * GP142_XMAX/4), TOP_OF_DIRT,
		   (GP142_XMAX)/3  , TOP_OF_DIRT,
		   -(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		   FILL);

  GP142_triangleXY(FOREST_GREEN,
		   -GP142_XMAX / 3 , TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, (2 * GP142_YMAX)/3 ,
		   FILL);
}



#define RAINDROP_WIDTH 3

void DrawRainDrop (int x, int y, int color) {
	GP142_circleXY (color,
		x, y,
		RAINDROP_WIDTH);
}

#define SNOWDROP_WIDTH 4
#define SNOWDROP_HEIGHT 5

void DrawSnowDrop (int x, int y, int color) {
	GP142_rectangleXY (color,
		x, y,
		x + SNOWDROP_WIDTH, y + SNOWDROP_HEIGHT,
		FILL);
}


/* draw a little pig, centered on the click */
void DrawCritter (int color, int x, int y) {
	GP142_ovalXY (color,	/* body */
		x - 5, y - 2,
		x + 6, y + 4,
		FILL);
	GP142_ovalXY (color,	/* head */
		x + 4, y + 2,
		x + 9, y + 7,
		FILL);
	GP142_lineXY (color,	/* leg 1 */
		x - 2, y - 6,
		x - 2, y,
		2);
	GP142_lineXY (color,	/* leg 2 */
		x + 4, y - 6,
		x + 4, y,
		2);
	GP142_lineXY (color,	/* tail	*/
		x - 9, y + 1,
		x - 5, y + 2,
		1);
}

/* SMITE THE EARTH FROM THE SKY!!!!  */
void DrawLightning (int x, int y, int x_slant) {
	GP142_triangleXY (YELLOW,
		x, y,
		x + x_slant, y + LIGHEIGHT,
		x + LIGWIDTH + x_slant, y + LIGHEIGHT,
		FILL);
}


/* draw a little char mark, centered on the click */
void DrawBurn (int center_x, int center_y) {

	GP142_ovalXY (BROWN,
		center_x - 18, center_y + 8,
		center_x + 18, center_y - 10,
		FILL);	
	GP142_ovalXY (MED_GRAY,
		center_x - 13, center_y + 5,
		center_x + 13, center_y - 7,
		FILL);	
	GP142_ovalXY (BLACK,
		center_x - 7, center_y + 2,
		center_x + 7, center_y - 3,
		FILL);
	GP142_lineXY (BLACK,
		center_x - 15, center_y + 1,
		center_x + 17, center_y - 1,
		1);
	GP142_lineXY (BLACK,
		center_x + 4, center_y + 9,
		center_x - 2, center_y - 6,
		1);
	GP142_lineXY (BLACK,
		center_x, center_y,
		center_x + 4, center_y - 12,
		1);
	GP142_lineXY (BLACK,
		center_x - 16, center_y - 5,
		center_x + 12, center_y + 2,
		1);
	GP142_lineXY (BLACK,
		center_x - 6, center_y + 6,
		center_x + 9, center_y - 9,
		1);
	GP142_lineXY (BLACK,
		center_x + 1, center_y + 8,
		center_x - 2, center_y - 12,
		1);
	GP142_lineXY (BLACK,
		center_x, center_y,
		center_x + 11, center_y + 6,
		1);
	GP142_lineXY (BLACK,
		center_x, center_y,
		center_x, center_y,
		1);
}




int  ClassifyMouseClick(int mouse_x, int mouse_y) {
	if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
		(mouse_y < GP142_YMAX) &&
		(mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
		return BUTTON;
	else if (mouse_y <= TOP_OF_DIRT)
		return DIRT;
	else
		return NONE;
}



/* Figure out which button was clicked */
void handle_button(int x, int y, int *current_precip, 
				   int *current_color, int *cur_ground, 
				   int *Wind_Flag, int *clear_weather)
{
  int buttonNum = 0;

  * clear_weather = FALSE;

  /* If we're outside of this area, we could not have clicked on
   * a button.
   */
  if (x > -GP142_XMAX + BUTTON_WIDTH)  return;

  /* We know the mouse clicked in the column of buttons. */
  buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 

  switch(buttonNum) {
  case 0:
    *current_precip = RAIN;
    break;
  case 1:
    *current_precip = SNOW;
    break;
  
  case 2:
    *current_color = WHITE;
    break;
  case 3:
    *current_color = BLUE;
    break;
  case 4:
	  *current_color = LT_GRAY;
	  break;
  case 5:
	  *cur_ground = PIGS;
	  break;
  case 6:
	  *cur_ground = BURN;
	  break;
  case 7:
	  if (*Wind_Flag == TRUE)	/* toggle wind on/off */
		  *Wind_Flag = FALSE;
	  else
		  *Wind_Flag = TRUE;
	  break;
  
  case 8:
    * clear_weather = TRUE;
    break; /* Signal to clear up the weather */
  default:
	/*Bad news if this is ever reached! */
    break;
  }

}


/* Draws the buttons */
void DrawButtons(int current_precip, int current_color, int cur_ground,
				 int Wind_Flag)
{
  int i, text_offset = -GP142_XMAX + 25, font_size = 15;

  /* draw rectangles for each button */
  for(i = 0; i < NUM_BUTTONS; i++) {
    GP142_rectangleXY(BLACK,
		      -GP142_XMAX + 4,
		      GP142_YMAX - i * BUTTON_HEIGHT - 2,
		      -GP142_XMAX + BUTTON_WIDTH,
		      GP142_YMAX - (i + 1)*BUTTON_HEIGHT - 2, 1);
  }

  /* display button text */
  /* "selected" buttons are highlighted (i.e., have a different color)*/
  /* This whole mess could be cleaned and put into a function
  if we could use strings. */
  i = GP142_YMAX - 25;
  if (current_precip == RAIN)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Rain");	
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Rain");	

  i -= BUTTON_HEIGHT;
  if (current_precip == SNOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Snow");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Snow");

 
  /* Buttons for Colors */
  i -= BUTTON_HEIGHT;
  if (current_color == WHITE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "White");	
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "White");

  i -= BUTTON_HEIGHT;
  if (current_color == BLUE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Blue");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Blue");

  i -= BUTTON_HEIGHT;
  if (current_color == LT_GRAY)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Ash");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Ash");

  i -= BUTTON_HEIGHT;
  if (cur_ground == PIGS)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Pigs");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Pigs");

  i -= BUTTON_HEIGHT;
  if (cur_ground == BURN)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, 
		"Smite!");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Smite!");

  i -= BUTTON_HEIGHT;
  if (Wind_Flag == TRUE)
	  GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Wind!");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Wind!");

  /* This button is never "selected" */
  i -= BUTTON_HEIGHT;
  GP142_printfXY(BLACK, text_offset, i, font_size, "Cease!");

}
